#ifndef AiboWeb_h_DEFINED
#define AiboWeb_h_DEFINED

#include <OPENR/OObject.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserver.h>
#include "TCPConnection.h"
#include "AiboWebConfig.h"
#include "def.h"

class AiboWeb : public OObject {
public:
    AiboWeb();
    virtual ~AiboWeb() {}

    OSubject*   subject[numOfSubject];
    OObserver*  observer[numOfObserver];     

    virtual OStatus DoInit   (const OSystemEvent& event);
    virtual OStatus DoStart  (const OSystemEvent& event);
    virtual OStatus DoStop   (const OSystemEvent& event);
    virtual OStatus DoDestroy(const OSystemEvent& event);

    void NotifyImage(const ONotifyEvent& event);

    void ListenCont (void* msg);
    void SendCont   (void* msg);
    void ReceiveCont(void* msg);
    void CloseCont  (void* msg);

private:
    OStatus Listen (int index);
    OStatus Send   (int index);
    OStatus Receive(int index);
    OStatus Close  (int index);
    OStatus InitTCPConnection(int index);

    void SetSendData(int index, OFbkImageVectorData* imageVec);
    void SetReceiveData(int index);

    void printRecvData(const char* src);

    antStackRef    ipstackRef;
    TCPConnection  connection[AIBOWEB_CONNECTION_MAX];
};

#endif // AiboWeb_h_DEFINED
